/*
 * 版权所有 (c) 2010-2011 MiCode 开源社区 (www.micode.net)
 *
 * 根据 Apache 许可证第 2.0 版（“许可证”）授权；
 * 您不得在未遵守许可证的情况下使用此文件。
 * 您可以在以下网址获得许可证的副本：
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * 除非适用法律要求或书面同意，否则根据许可证分发的软件
 * 是在“按原样”基础上分发的，不附带任何明示或暗示的担保或条件。
 * 有关许可证下权限和限制的具体语言，请参阅许可证。
 */

package net.micode.notes.gtask.data; // 定义包名

import android.content.ContentResolver; // 导入ContentResolver类，用于管理内容提供者的操作
import android.content.ContentUris; // 导入ContentUris类，用于构造内容URI
import android.content.ContentValues; // 导入ContentValues类，用于存储行的列值
import android.content.Context; // 导入Context类，表示应用环境
import android.database.Cursor; // 导入Cursor类，用于访问数据库查询结果
import android.net.Uri; // 导入Uri类，用于表示内容的URI
import android.util.Log; // 导入Log类，用于记录调试信息

import net.micode.notes.data.Notes; // 导入Notes类，表示笔记相关的数据结构
import net.micode.notes.data.Notes.DataColumns; // 导入数据列常量
import net.micode.notes.data.Notes.DataConstants; // 导入数据常量
import net.micode.notes.data.Notes.NoteColumns; // 导入笔记列常量
import net.micode.notes.data.NotesDatabaseHelper.TABLE; // 导入数据库表名常量
import net.micode.notes.gtask.exception.ActionFailureException; // 导入自定义异常类

import org.json.JSONException; // 导入JSONException类，用于处理JSON异常
import org.json.JSONObject; // 导入JSONObject类，表示一个JSON对象


public class SqlData { // 定义SqlData类
    private static final String TAG = SqlData.class.getSimpleName(); // 定义日志标签

    private static final int INVALID_ID = -99999; // 定义无效ID常量

    // 定义数据投影数组，包含要查询的列
    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    };

    // 列索引常量
    public static final int DATA_ID_COLUMN = 0;
    public static final int DATA_MIME_TYPE_COLUMN = 1;
    public static final int DATA_CONTENT_COLUMN = 2;
    public static final int DATA_CONTENT_DATA_1_COLUMN = 3;
    public static final int DATA_CONTENT_DATA_3_COLUMN = 4;

    private ContentResolver mContentResolver; // 内容解析器实例
    private boolean mIsCreate; // 标记是否为创建状态
    private long mDataId; // 数据ID
    private String mDataMimeType; // 数据MIME类型
    private String mDataContent; // 数据内容
    private long mDataContentData1; // 数据内容的第一个额外字段
    private String mDataContentData3; // 数据内容的第三个额外字段
    private ContentValues mDiffDataValues; // 存储变化的数据值

    // 构造函数，用于创建新的SqlData实例
    public SqlData(Context context) {
        mContentResolver = context.getContentResolver(); // 获取内容解析器
        mIsCreate = true; // 设置为创建状态
        mDataId = INVALID_ID; // 初始化ID为无效值
        mDataMimeType = DataConstants.NOTE; // 默认MIME类型为笔记
        mDataContent = ""; // 初始化内容为空
        mDataContentData1 = 0; // 第一个数据字段初始化为0
        mDataContentData3 = ""; // 第三个数据字段初始化为空
        mDiffDataValues = new ContentValues(); // 创建内容值实例
    }

    // 构造函数，用于从游标中加载SqlData实例
    public SqlData(Context context, Cursor c) {
        mContentResolver = context.getContentResolver(); // 获取内容解析器
        mIsCreate = false; // 设置为非创建状态
        loadFromCursor(c); // 从游标加载数据
        mDiffDataValues = new ContentValues(); // 创建内容值实例
    }

    // 从游标中加载数据到SqlData实例
    private void loadFromCursor(Cursor c) {
        mDataId = c.getLong(DATA_ID_COLUMN); // 获取数据ID
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN); // 获取MIME类型
        mDataContent = c.getString(DATA_CONTENT_COLUMN); // 获取内容
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN); // 获取第一个数据字段
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN); // 获取第三个数据字段
    }

    // 设置内容，从JSONObject填充数据
    public void setContent(JSONObject js) throws JSONException {
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID; // 获取ID
        if (mIsCreate || mDataId != dataId) { // 如果是创建状态或ID不相等
            mDiffDataValues.put(DataColumns.ID, dataId); // 更新变化的ID值
        }
        mDataId = dataId; // 更新数据ID

        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE; // 获取MIME类型
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) { // 如果是创建状态或MIME类型不同
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType); // 更新变化的MIME类型
        }
        mDataMimeType = dataMimeType; // 更新MIME类型

        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : ""; // 获取内容
        if (mIsCreate || !mDataContent.equals(dataContent)) { // 如果是创建状态或内容不同
            mDiffDataValues.put(DataColumns.CONTENT, dataContent); // 更新变化的内容
        }
        mDataContent = dataContent; // 更新内容

        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0; // 获取第一个数据字段
        if (mIsCreate || mDataContentData1 != dataContentData1) { // 如果是创建状态或字段不同
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1); // 更新变化的第一个数据字段
        }
        mDataContentData1 = dataContentData1; // 更新第一个数据字段

        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : ""; // 获取第三个数据字段
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) { // 如果是创建状态或字段不同
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3); // 更新变化的第三个数据字段
        }
        mDataContentData3 = dataContentData3; // 更新第三个数据字段
    }

    // 获取内容，返回为JSONObject
    public JSONObject getContent() throws JSONException {
        if (mIsCreate) { // 如果是创建状态
            Log.e(TAG, "it seems that we haven't created this in database yet"); // 记录错误日志
            return null; // 返回null
        }
        JSONObject js = new JSONObject(); // 创建新的JSON对象
        // 将数据添加到JSON对象中
        js.put(DataColumns.ID, mDataId);
        js.put(DataColumns.MIME_TYPE, mDataMimeType);
        js.put(DataColumns.CONTENT, mDataContent);
        js.put(DataColumns.DATA1, mDataContentData1);
        js.put(DataColumns.DATA3, mDataContentData3);
        return js; // 返回填充的JSON对象
    }

    // 提交更改到数据库
    public void commit(long noteId, boolean validateVersion, long version) {

        if (mIsCreate) { // 如果是创建状态
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) { // 如果ID无效且变化值中包含ID
                mDiffDataValues.remove(DataColumns.ID); // 移除变化值中的ID
            }

            mDiffDataValues.put(DataColumns.NOTE_ID, noteId); // 添加笔记ID到变化值
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues); // 插入数据
            try {
                mDataId = Long.valueOf(uri.getPathSegments().get(1)); // 获取新创建的ID
            } catch (NumberFormatException e) { // 捕获数字格式异常
                Log.e(TAG, "Get note id error :" + e.toString()); // 记录错误日志
                throw new ActionFailureException("create note failed"); // 抛出创建失败异常
            }
        } else { // 如果不是创建状态
            if (mDiffDataValues.size() > 0) { // 如果有变化值
                int result = 0; // 定义返回结果
                if (!validateVersion) { // 如果不验证版本
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null); // 更新数据
                } else { // 如果验证版本
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            }); // 根据版本更新数据
                }
                if (result == 0) { // 如果没有更新行
                    Log.w(TAG, "there is no update. maybe user updates note when syncing"); // 记录警告日志
                }
            }
        }

        mDiffDataValues.clear(); // 清空变化的数据值
        mIsCreate = false; // 设置为非创建状态
    }

    // 获取数据ID
    public long getId() {
        return mDataId; // 返回数据ID
    }
}
